/*******************************************************************************
 * FoxWeapon_ChargeLauncherBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_ChargeLauncherBase extends FoxWeapon_LauncherBase
    abstract
    native(Weapon)
    config(Launcher)
    hidecategories(Navigation);

enum EBowChargeState
{
    EBCS_Idle,
    EBCS_HipChargingActive,
    EBCS_HipChargingInactive,
    EBCS_HipCharged,
    EBCS_TACharging,
    EBCS_TACharged,
    EBCS_MAX
};

enum ChargeMeleeType
{
    CMT_Normal,
    CMT_Miss,
    CMT_NoAmmo,
    CMT_MAX
};

var const float TAChargeTimeToFire;
var const float HipChargeTimeToFire;
var const float FireReleaseAnimTime;
var FoxWeapon_ChargeLauncherBase.EBowChargeState ChargeState;
var FoxWeapon_ChargeLauncherBase.ChargeMeleeType CurrentMeleeType;
var(Animation) WeaponAnimSet AN_TAChargeWeapon;
var(Animation) WeaponAnimSet AN_HipChargeWeapon;
var(Animation) WeaponAnimSet AN_HipChargeIdle;
var(Animation) WeaponAnimSet AN_MeleeFail;
var(Animation) WeaponAnimSet AN_MeleeNoAmmo;
var AnimNodeSequence ChargeSequence;
var AnimNodeSequence WeaponChargeSequence;
var const name ChargeTimerName;
var config GameBalanceRange CockRateRange;
var(Animation) float CockRate;
var const name MeleeArrowSocketName;
var() Rotator MeleeArrowRotation;
var() Vector MeleeArrowOffset;
var() Rotator MeleeProjectileRotationOffset;
var const config float HipFireDamageReduction;
var const config float MinTADamageReduction;
var bool bLastShotHipFire;
var bool bMeleeHasAmmo;
var bool bChargingLoopPlaying;
var float LastShotChargeProgress;
var() const config float HipfireSpeedReduction;
var() const config float ChargedMaxSpeedReduction;
var() const config float TAChargeSpeedExponent;
var() const config float TAChargeDamageExponent;
var float DefaultTightAimSpread;
var AkEvent StartChargingLoop;
var AkEvent EndChargingLoop;
var AkEvent ChargeCompleteSound;
var const name RTPCChargeProgressName;

replication
{
    // Pos:0x000
    if(!bNetOwner)
        ChargeState
}

simulated function StartFire(byte FireModeNum)
{
    // End:0x1D
    if(FireModeNum == 0)
    {
        FireModeNum = 3;
    }
    super.StartFire(FireModeNum);
    //return;    
}

simulated function StopFire(byte FireModeNum)
{
    // End:0x1D
    if(FireModeNum == 0)
    {
        FireModeNum = 3;
    }
    super(Weapon).StopFire(FireModeNum);
    //return;    
}

simulated function TryToGetBackToFiringState()
{
    local FoxPC FPC;

    // End:0x128
    if(Instigator.IsHumanControlled() && BurstFireMax == 0)
    {
        FPC = FoxPC(Instigator.Controller);
        // End:0x128
        if(((((FPC != none) && FPC.PlayerInput != none) && FPC.MyFoxInput.bHoldingFiringButton) && FPC.CanFireWeapon(self)) && FPC.CanUseWeapon())
        {
            StartFire(0);
        }
    }
    //return;    
}

simulated function ChargeComplete()
{
    //return;    
}

simulated function StartChargeLoop()
{
    //return;    
}

simulated function StopChargeLoop()
{
    // End:0x31
    if(bChargingLoopPlaying)
    {
        PlayAkEvent(EndChargingLoop, true, true, true);
        bChargingLoopPlaying = false;
    }
    //return;    
}

// Export UFoxWeapon_ChargeLauncherBase::execSetChargeSequence(FFrame&, void* const)
native simulated function SetChargeSequence();

// Export UFoxWeapon_ChargeLauncherBase::execIsChargeSequenceValid(FFrame&, void* const)
native simulated function bool IsChargeSequenceValid();

simulated function StartFireAnim(byte FireModeNum)
{
    local float AnimStartTime;

    switch(FoxPawn(Instigator).CurrentZoomState)
    {
        // End:0x36
        case 0:
        // End:0x79
        case 1:
            PlayWeaponSet(AN_NormalFire, AN_NormalFire.RateMultiplier, bAutomaticWeapon, true);
            // End:0xF1
            break;
        // End:0x7E
        case 2:
        // End:0xEE
        case 3:
            AnimStartTime = (1.0 - LastShotChargeProgress) * FireReleaseAnimTime;
            PlayWeaponSet(AN_TightAimFire, AN_TightAimFire.RateMultiplier, bAutomaticWeapon, true, AnimStartTime);
            // End:0xF1
            break;
        // End:0xFFFF
        default:
            // End:0x120
            if(MagazineMod != none)
            {
                MagazineMod.SetHiddenOverride(true);
            }
            // End:0x170
            if(FireModeNum != 1)
            {
                FoxPawn(Instigator).LocalPawnDialog("Attack", 2, GetWeaponDialogName());
            }
            //return;
    }    
}

simulated function StartReloadAnim(optional byte FireMode)
{
    super(FoxWeapon).StartReloadAnim(FireMode);
    SetTimer(0.10 * WeaponReloadRate, false, 'TimedUnhideMagazine');
    // End:0x122
    if(((Role == ROLE_Authority) || Instigator.IsLocallyControlled()) && FoxWeaponAttachment_CompoundBowBase(FoxPawn(Instigator).AttachSlots[0].ThirdPersonWeapon) != none)
    {
        FoxWeaponAttachment_CompoundBowBase(FoxPawn(Instigator).AttachSlots[0].ThirdPersonWeapon).SetUnhideMagazineTimer(0.10 * WeaponReloadRate);
    }
    //return;    
}

simulated function TimedUnhideMagazine()
{
    // End:0x2F
    if(MagazineMod != none)
    {
        MagazineMod.SetHiddenOverride(false);
    }
    //return;    
}

simulated event ApplyRecoil()
{
    local float Alpha;

    // End:0x13F
    if(CockRateRange.Base != float(0))
    {
        Alpha = Abs(float(CoalescedWeaponModInfo.Recoil) / 100.0);
        // End:0xC7
        if(CoalescedWeaponModInfo.Recoil > 0)
        {
            CockRate = Lerp(CockRateRange.Base, CockRateRange.Max, Alpha);
        }
        // End:0x114
        else
        {
            CockRate = Lerp(CockRateRange.Base, CockRateRange.Min, Alpha);
        }
        // End:0x13F
        if(CockRate > float(0))
        {
            CockRate = 1.0 / CockRate;
        }
    }
    super(FoxWeapon).ApplyRecoil();
    //return;    
}

simulated function HideMagazineTimer()
{
    //return;    
}

simulated function float StartFPMeleeAnim(bool bHitSomething)
{
    // End:0x1E
    if(!bMeleeHasAmmo)
    {
        CurrentMeleeType = 2;
    }
    // End:0x59
    else
    {
        // End:0x4D
        if(bHitSomething)
        {
            CurrentMeleeType = 0;
            SetTimer(0.150, false, 'HideMagazineTimer');
        }
        // End:0x59
        else
        {
            CurrentMeleeType = 1;
        }
    }
    return super(FoxWeapon).StartFPMeleeAnim(bHitSomething);
    //return ReturnValue;    
}

reliable server function SetMeleeTarget(Pawn NewMeleeTarget, ImpactInfo Impact, bool bIsQuickThrow)
{
    local FoxProjectile_DartBase SpawnedProjectile;
    local FoxOnlineStatsWriteWeaponUse WriteWeaponUse;

    StartMelee();
    // End:0x41
    if(!HasAnyAmmo())
    {
        super(FoxWeapon).SetMeleeTarget(NewMeleeTarget, Impact, bIsQuickThrow);
        return;
    }
    // End:0x428
    if(Impact.HitActor != none)
    {
        -- SpareAmmoCount;
        SpawnedProjectile = FoxProjectile_DartBase(Spawn(WeaponProjectiles[0], self,, Impact.HitLocation,,, true));
        // End:0x381
        if((SpawnedProjectile != none) && !SpawnedProjectile.bDeleteMe)
        {
            // End:0x16E
            if(SpawnedProjectile.bExplodeOnStick)
            {
                SpawnedProjectile.bExplodeOnStick = false;
                SpawnedProjectile.MyDamageType = default.WeaponProjectiles[0].default.MyDamageType;
            }
            // End:0x1CC
            if(FoxProjectile_ArrowBase(SpawnedProjectile) != none)
            {
                SpawnedProjectile.FirstBounceDamage = FoxProjectile_ArrowBase(SpawnedProjectile).MeleeDamage;
            }
            SpawnedProjectile.SetPRI(Instigator.PlayerReplicationInfo);
            SpawnedProjectile.DelayCanBePickedup();
            SpawnedProjectile.bPassThroughPawns = false;
            SpawnedProjectile.Velocity = vector(RTransform(MeleeProjectileRotationOffset, Instigator.Controller.Rotation)) * SpawnedProjectile.Speed;
            SpawnedProjectile.StartGrenadeTimer(0.0);
            SpawnedProjectile.HandleCollision(Impact.HitActor, Impact.HitLocation, Impact.HitNormal);
            SpawnedProjectile.SetPhysics(0);
        }
        // End:0x428
        if(WorldInfo.IsServer() && FoxPawn(Instigator) != none)
        {
            WriteWeaponUse = FoxPawn(Instigator).GetStatsWriteWeaponUse(Class);
            // End:0x428
            if(WriteWeaponUse != none)
            {
                WriteWeaponUse.IncrementRoundsFired(0);
            }
        }
    }
    // End:0x475
    if(!Instigator.IsLocallyControlled())
    {
        StartFPMeleeAnim(Impact.HitActor != none);
    }
    //return;    
}

simulated function float StartMeleeAnim(optional float PrecentOfAnimLength)
{
    local float MeleeTime;

    PrecentOfAnimLength = 1.0;
    // End:0x63
    if(CurrentMeleeType == 2)
    {
        MeleeTime = PlayWeaponSet(AN_MeleeNoAmmo, 1.0, false, true);
        SetTimer(MeleeTime, false, 'StopMeleeAnim');
        return MeleeTime;
    }
    // End:0xBD
    if(CurrentMeleeType == 1)
    {
        MeleeTime = PlayWeaponSet(AN_MeleeFail, 1.0, false, true);
        SetTimer(MeleeTime, false, 'StopMeleeAnim');
        return MeleeTime;
    }
    return super(FoxWeapon).StartMeleeAnim();
    //return ReturnValue;    
}

simulated function Projectile ProjectileFire()
{
    local FoxProjectile_ArrowBase SpawnedProj;
    local float SpeedReductionMult, DamageReductionPercent;

    SpawnedProj = FoxProjectile_ArrowBase(super(FoxWeapon).ProjectileFire());
    // End:0x1A6
    if(SpawnedProj != none)
    {
        // End:0x7F
        if(bLastShotHipFire)
        {
            SpeedReductionMult = HipfireSpeedReduction;
            DamageReductionPercent = 0.0;
            SpawnedProj.bPassThroughPawns = false;
        }
        // End:0x117
        else
        {
            SpeedReductionMult = FInterpEaseIn(ChargedMaxSpeedReduction, 1.0, LastShotChargeProgress, TAChargeSpeedExponent);
            DamageReductionPercent = FInterpEaseIn(0.0, 1.0, LastShotChargeProgress, TAChargeDamageExponent);
            // End:0x117
            if(LastShotChargeProgress < 1.0)
            {
                SpawnedProj.bPassThroughPawns = false;
            }
        }
        SpawnedProj.Velocity *= SpeedReductionMult;
        SpawnedProj.FirstBounceDamage = Lerp(SpawnedProj.MinDamage, SpawnedProj.MaxDamage, DamageReductionPercent);
    }
    return SpawnedProj;
    //return ReturnValue;    
}

simulated function FireAmmunition()
{
    bLastShotHipFire = !InZoom();
    super(FoxWeapon_SemiAutomaticRifleBase).FireAmmunition();
    //return;    
}

simulated event ApplyAccuracy()
{
    super(FoxWeapon).ApplyAccuracy();
    DefaultTightAimSpread = TABaseSpread[0];
    //return;    
}

simulated function InitializeAttachments()
{
    super(FoxWeapon).InitializeAttachments();
    SetEmissives();
    //return;    
}

// Export UFoxWeapon_ChargeLauncherBase::execCanSprint(FFrame&, void* const)
native simulated function bool CanSprint();

simulated function NotifyLocalPlayerTeamReceived()
{
    super(Actor).NotifyLocalPlayerTeamReceived();
    // End:0x3D
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        SetEmissives();
    }
    //return;    
}

simulated function SetEmissives()
{
    local int I;
    local FoxGRI GRI;
    local LinearColor EmissiveColor;

    GRI = FoxGRI(WorldInfo.GRI);
    // End:0x143
    if((GRI != none) && MagazineMod != none)
    {
        EmissiveColor = GRI.GetEmissiveColorForTeam(Instigator.PlayerReplicationInfo);
        I = 0;
        J0xA3:
        // End:0x143 [Loop If]
        if(I < MagazineMod.FPCamoMICs.Length)
        {
            MagazineMod.FPCamoMICs[I].SetVectorParameterValue(class'FoxProjectile_GrenadeBase'.default.EmissiveColorParamName, EmissiveColor);
            ++ I;
            // [Loop Continue]
            goto J0xA3;
        }
    }
    //return;    
}

simulated state ChargeWeapon
{
    ignores TryToGetBackToFiringState;

    simulated function BeginState(name PreviousStateName)
    {
        SetupSimulatedState();
        StartChargeSequence(InZoom());
        //return;        
    }

    simulated function StartChargeSequence(bool bTightAim)
    {
        local WeaponAnimSet ChargeAnimSet;
        local float ChargeTime;

        // End:0x6B
        if(bTightAim)
        {
            ChargeState = 4;
            ChargeAnimSet = AN_TAChargeWeapon;
            ChargeTime = TAChargeTimeToFire;
            TABaseSpread[0] = DefaultTightAimSpread;
            SetChargeSequence();
            StartChargeLoop();
        }
        // End:0x119
        else
        {
            ChargeState = 1;
            ChargeAnimSet = AN_HipChargeWeapon;
            ChargeTime = HipChargeTimeToFire;
            // End:0x119
            if(FoxPawn(Instigator).CurrentZoomState == 0)
            {
                FoxPawn(Instigator).CurrentZoomState = 1;
                // End:0x119
                if(Role < ROLE_Authority)
                {
                    ServerSetZoomState(ROLE_SimulatedProxy);
                }
            }
        }
        // End:0x13E
        if(CockRate > float(0))
        {
            ChargeTime /= CockRate;
        }
        SetTimer(ChargeTime, false, ChargeTimerName);
        FoxPawn(Instigator).PlayFirstPersonCustomAnim(ChargeAnimSet.FP_Anim, CockRate * ChargeAnimSet.RateMultiplier, ChargeAnimSet.BlendInTime, ChargeAnimSet.BlendOutTime);
        PlayWeaponAnim(ChargeAnimSet.WP_Anim, CockRate * ChargeAnimSet.RateMultiplier, ChargeAnimSet.BlendInTime, ChargeAnimSet.BlendOutTime);
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        StopChargeLoop();
        // End:0x71
        if(InZoom())
        {
            StopWeaponSet(AN_TAChargeWeapon);
            // End:0x71
            if(IsTimerActive(ChargeTimerName))
            {
                LastShotChargeProgress = 1.0 - (GetRemainingTimeForTimer(ChargeTimerName) / TAChargeTimeToFire);
            }
        }
        ClearTimer(ChargeTimerName);
        ChargeState = 0;
        // End:0x10D
        if(FoxPawn(Instigator).CurrentZoomState == 1)
        {
            FoxPawn(Instigator).CurrentZoomState = 0;
            // End:0x10D
            if(Role < ROLE_Authority)
            {
                ServerSetZoomState(ROLE_None);
            }
        }
        super(FoxWeapon).EndState(NextStateName);
        //return;        
    }

    simulated function BeginFire(byte FireModeNum)
    {
        // End:0x27
        if(ChargeState == 3)
        {
            super(Weapon).BeginFire(FireModeNum);
        }
        //return;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        // End:0x58
        if((ChargeState >= 3) && ChargeState <= 5)
        {
            StartFire(0);
            SendToFiringState(0);
            super(Weapon).EndFire(FireModeNum);
        }
        // End:0xA2
        else
        {
            // End:0x7B
            if(ChargeState == 1)
            {
                ChargeState = 2;
            }
            // End:0xA2
            else
            {
                // End:0xA2
                if(ChargeState == 0)
                {
                    super(Weapon).EndFire(FireModeNum);
                }
            }
        }
        //return;        
    }

    simulated function ChargeComplete()
    {
        // End:0x54
        if(InZoom())
        {
            LastShotChargeProgress = 1.0;
            ChargeState = 5;
            PlayAkEvent(ChargeCompleteSound, true, true, true);
            TABaseSpread[0] = 0.0;
        }
        // End:0x1A7
        else
        {
            // End:0x83
            if(ChargeState == 2)
            {
                ChargeState = 3;
                EndFire(0);
            }
            // End:0x1A7
            else
            {
                FoxPawn(Instigator).PlayFirstPersonCustomAnim(AN_HipChargeIdle.FP_Anim, AN_HipChargeIdle.RateMultiplier, AN_HipChargeIdle.BlendInTime, AN_HipChargeIdle.BlendOutTime, true);
                PlayWeaponAnim(AN_HipChargeIdle.WP_Anim, AN_HipChargeIdle.RateMultiplier, AN_HipChargeIdle.BlendInTime, AN_HipChargeIdle.BlendOutTime, true);
                ChargeState = 3;
            }
        }
        //return;        
    }

    simulated function bool TryPutDown()
    {
        ClearTimer(ChargeTimerName);
        StopChargeLoop();
        PutDownWeapon();
        return true;
        //return ReturnValue;        
    }

    simulated function StartChargeLoop()
    {
        // End:0x33
        if(!bChargingLoopPlaying)
        {
            PlayAkEvent(StartChargingLoop, true, true, true);
            bChargingLoopPlaying = true;
        }
        //return;        
    }

    simulated function StepZoom()
    {
        local FoxPC FPC;
        local FoxPawn.ZoomState OriginalZoomState;

        OriginalZoomState = FoxPawn(Instigator).CurrentZoomState;
        // End:0x13B
        if(OriginalZoomState == 2)
        {
            // End:0x115
            if(Instigator.IsHumanControlled() && BurstFireMax == 0)
            {
                FPC = FoxPC(Instigator.Controller);
                // End:0x115
                if((FPC != none) && FPC.MyFoxInput != none)
                {
                    FPC.MyFoxInput.bHoldingFiringButton = false;
                }
            }
            ChargeState = 0;
            EndFire(3);
            GotoState('Active');
        }
        super(FoxWeapon).StepZoom();
        // End:0x198
        if((FoxPawn(Instigator).CurrentZoomState >= 2) && OriginalZoomState < 2)
        {
            StartChargeSequence(true);
        }
        //return;        
    }

    protected reliable server function ServerSetZoomState(const FoxPawn.ZoomState NewZoomStep)
    {
        local FoxPawn.ZoomState OriginalZoomState;

        OriginalZoomState = FoxPawn(Instigator).CurrentZoomState;
        // End:0x81
        if((NewZoomStep == 0) && OriginalZoomState >= 2)
        {
            ChargeState = 0;
            EndFire(3);
            GotoState('Active');
        }
        super(FoxWeapon).ServerSetZoomState(NewZoomStep);
        // End:0xC9
        if((OriginalZoomState < 2) && NewZoomStep >= 2)
        {
            StartChargeSequence(true);
        }
        //return;        
    }
    stop;    
}

simulated state Melee
{
    ignores StartMelee;

    simulated function BeginState(name PreviousStateName)
    {
        // End:0x50
        if(HasAmmo(0))
        {
            ++ AmmoUsedCount;
            ++ SimulatedAmmoUsedCount;
            ++ SeedIndex;
            AmmoLeftCount = GetAmmoLeftInMagazine();
            ++ SpareAmmoCount;
        }
        bMeleeHasAmmo = SpareAmmoCount > 0;
        // End:0x1BB
        if((((Instigator != none) && Instigator.IsFirstPerson()) && MagazineMod != none) && bMeleeHasAmmo)
        {
            MagazineMod.SetHiddenOverride(false);
            FoxPawn(Instigator).FirstPersonMesh.AttachComponentToSocket(MagazineMod.GetFPMeshComp(), MeleeArrowSocketName);
            MagazineMod.GetFPMeshComp().SetRotation(MeleeArrowRotation);
            MagazineMod.GetFPMeshComp().SetTranslation(MeleeArrowOffset);
        }
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function HideMagazineTimer()
    {
        // End:0x2F
        if(MagazineMod != none)
        {
            MagazineMod.SetHiddenOverride(true);
        }
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        // End:0x116
        if((Instigator != none) && Instigator.IsFirstPerson())
        {
            // End:0x116
            if(MagazineMod != none)
            {
                SkeletalMeshComponent(Mesh).AttachComponentToSocket(MagazineMod.GetFPMeshComp(), MagazineSocketName);
                MagazineMod.GetFPMeshComp().SetRotation(rot(0, 0, 0));
                MagazineMod.GetFPMeshComp().SetTranslation(vect(0.0, 0.0, 0.0));
            }
        }
        super.EndState(NextStateName);
        //return;        
    }

    simulated function StopMeleeAnim()
    {
        HideMagazineTimer();
        // End:0xAB
        if(CurrentMeleeType == 2)
        {
            FoxPawn(Instigator).StopFirstAndThirdPersonAnim(AN_MeleeNoAmmo.FP_Anim, AN_MeleeNoAmmo.TP_Anim, AN_MeleeNoAmmo.AbortBlendOutTime);
            GotoState('Active');
        }
        // End:0x156
        else
        {
            // End:0x14C
            if(CurrentMeleeType != 1)
            {
                FoxPawn(Instigator).StopFirstAndThirdPersonAnim(AN_MeleeFail.FP_Anim, AN_MeleeFail.TP_Anim, AN_MeleeFail.AbortBlendOutTime);
                GotoState('Active');
            }
            // End:0x156
            else
            {
                super.StopMeleeAnim();
            }
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    TAChargeTimeToFire=0.8330
    HipChargeTimeToFire=0.26670
    FireReleaseAnimTime=0.040
    AN_TAChargeWeapon=(TP_Anim=(AnimName=(None,None,None)),FP_Anim=Draw_A,WP_Anim=Draw_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.050,AbortBlendOutTime=0.050)
    AN_HipChargeWeapon=(TP_Anim=(AnimName=(None,None,None)),FP_Anim=DrawHip,WP_Anim=DrawHip,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.0,AbortBlendOutTime=0.050)
    AN_HipChargeIdle=(TP_Anim=(AnimName=(None,None,None)),FP_Anim=IdleHip,WP_Anim=IdleHip,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.0,BlendOutTime=0.050,AbortBlendOutTime=0.050)
    AN_MeleeFail=(TP_Anim=(AnimName=(None,None,Melee_A)),FP_Anim=MeleeFail_A,WP_Anim=Idle_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    AN_MeleeNoAmmo=(TP_Anim=(AnimName=(None,None,Melee_A)),FP_Anim=MeleeEmpty_A,WP_Anim=Idle_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.250,AbortBlendOutTime=0.10)
    ChargeTimerName=ChargeComplete
    CockRate=1.0
    MeleeArrowSocketName=S_Knife
    MeleeArrowRotation=(Pitch=32768,Yaw=0,Roll=0)
    MeleeArrowOffset=(X=0.0,Y=0.0,Z=75.0)
    MeleeProjectileRotationOffset=(Pitch=0,Yaw=4096,Roll=0)
    RTPCChargeProgressName=Bow_Pull
    bResetZoomInputOnStop=false
    bSupportsScopeMods=false
    bSupportsHangerMods=false
    WeaponIronSightName=S_IronSight_Pistol
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_ChargeLauncherBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_ChargeLauncherBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_ChargeLauncherBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_ChargeLauncherBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.88741720
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_ChargeLauncherBase.LensComp'
    MuzzleLensFlare=LensComp
    AN_FullReload=(TP_Anim=(AnimName=(None,None,Reload_B)),FP_Anim=Reload_B,WP_Anim=Reload_B,BlendInTime=0.250)
    AN_NormalFire=(FP_Anim=AttackHip,WP_Anim=AttackHip,HG_Anim=AttackHip,BlendInTime=0.0,BlendOutTime=0.150,AbortBlendOutTime=0.10)
    AN_ScopedFire=(TP_Anim=(AnimName=(None,None,Attack_A)))
    AN_TightAimFire=(TP_Anim=(AnimName=(None,None,Attack_A)),FP_Anim=Attack_A)
    FiringStatesArray=/* Array type was not detected. */
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_ChargeLauncherBase.WeaponMesh'
    Mesh=WeaponMesh
}